#include <f1ll/ringbuffer.h>

#include <iostream>

using namespace std;

int main()
{
  f1ll::ringbuffer<8> rb;
  uint8_t dst_buffer[7];
  uint8_t data1[] = {0, 1, 2, 3};
  uint8_t data2[] = {4, 5, 6, 7};

  int16_t added = rb.put(data1, sizeof(data1));
  cout << "Added " << added << " bytes to the buffer. It reports " << rb.uncommited() << " uncommited and " << rb.commited()
       << " commited bytes." << endl;
  rb.commit();
  cout << "After commit, there are " << rb.commited() << " commited and " << rb.uncommited() << " uncommited bytes in the buffer" << endl;
  added = rb.put(data1, sizeof(data1));
  cout << "Added " << added << " bytes to the buffer. It reports " << rb.uncommited() << " uncommited and " << rb.commited()
       << " commited bytes." << endl;
  rb.commit();
  cout << "After commit, there are " << rb.commited() << " commited and " << rb.uncommited() << " uncommited bytes in the buffer" << endl;
}
